import React from 'react';
import { BrowserRouter, Route } from "react-router-dom";
import './SearchFilm.css';
import axios from "axios"
import ReactDOM from "react-dom"
import SearchForm from "../SearchForm/SearchForm"
import CloseButton from "../CloseButton/CloseButtton"



let searchResultList;
class SearchFilm extends React.Component {

  constructor() {
    super()


  }
  state = {
    searchKey: "",
    searchResult: [],
    renderChild: false,
    filmSelected: false,
    selectedFilmDiv: null
  }


  searchFilmByTitle = (e) => {
    e.preventDefault();
    axios.get("http://www.omdbapi.com/?s=" + this.state.searchKey + "&apikey=511559d3").then(res => {
      this.setState({
        searchResult: res.data
      });

    })
  }

  handleChange = (e) => {
    this.setState({ searchKey: e.target.value })
  }

  handclick = (e) => {
    this.setState({ renderChild: true })
    ReactDOM.findDOMNode(e.target).parentNode.className = "selectedFilm"
    this.setState({ selectedFilmDiv: ReactDOM.findDOMNode(e.target).parentNode })
    this.setState({ filmSelected: true })

  }
  handleChildUnmount() {
    this.setState({ renderChild: false });
  }

  removeSelectedFilm = (e) => {

    this.state.selectedFilmDiv.className = "film-card"
    this.setState({ selectedFilmDiv: null })
    this.setState({ renderChild: false });
    this.setState({ filmSelected: false })
  }

  render() {

    if (this.state.searchResult.Search !== undefined) {
      searchResultList = this.state.searchResult.Search.map((film) => {
        return (
          <div key={film.imdbID} className="film-card" onClick={this.handclick} id={film.imdbID} ref="testingRef">
            <img className="" src={film.Poster} ></img>
            <p >{film.Title}</p>
            <p>year: {film.Year}</p>
            <p>imdbID: {film.imdbID}</p>
          </div>)
      })

    }

    return (
      <React.Fragment>


        {this.state.filmSelected ? <CloseButton removeSelectedFilm={this.removeSelectedFilm} /> : null}
        <SearchForm searchFilmByTitle={this.searchFilmByTitle} handleChange={this.handleChange} />

        <div className="cards-wrapper">
          {searchResultList}



        </div>
      </React.Fragment>
    )
  }
}

export default SearchFilm;
