import { Injectable } from '@angular/core';
import {HttpClient, HttpHeaders} from '@angular/common/http';
import {Observable} from 'rxjs';

@Injectable({
  providedIn: 'root'
})
export class ApiService {

  private apiBaseUrl: string;
  private apiAuthKey: string;

  constructor(private http: HttpClient) {
    this.apiBaseUrl = 'api/';
    this.apiAuthKey = '&apikey=511559d3';
  }

  private http_headers = new HttpHeaders({
    'Content-Type': 'application/json; charset=utf-8'
  });

  search(query: String, page: number): Observable<any> {
    return this.get('?s=' + query + '&page=' + page);
  }

  searchByTitle(title: string): Observable<any> {
    return this.get('?t=' + title);
  }

  get(queryString: string): Observable<any> {
      return this.http.get(this.apiBaseUrl + queryString + this.apiAuthKey, {headers: this.http_headers});
  }

  post(queryString: string, body: any): Observable<any> {
      return this.http.post(this.apiBaseUrl + queryString + this.apiAuthKey, {headers: this.http_headers});
  }
}
